unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MPlayer, ExtCtrls, ShellAPI, jpeg, ComCtrls, mmSystem;

Const WM_MYMESSAGE=WM_USER+100;

type
TID3Tag = record
ID:string[3];
Titel:string[30];
Artist:string[30];
Album:string[30];
Year:string[4];
Comment:string[30];
Genre:byte;
end;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    ListBox1: TListBox;
    MediaPlayer1: TMediaPlayer;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label9: TLabel;
    Image1: TImage;
    Label8: TLabel;
    Label10: TLabel;
    play: TImage;
    stop: TImage;
    stopoff: TImage;
    stopon: TImage;
    playoff: TImage;
    playon: TImage;
    plusoff: TImage;
    pluson: TImage;
    moinsoff: TImage;
    moinson: TImage;
    plus: TImage;
    moins: TImage;
    Label1: TLabel;
    Image2: TImage;
    optionoff: TImage;
    optionon: TImage;
    option: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Procedure RegleVolume;
    procedure Timer1Timer(Sender: TObject);
    procedure loadopt();
    procedure saveopt();
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Label9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Label8Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure stopMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure stopMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure playMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure playMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure plusMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure plusMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moinsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure moinsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure playClick(Sender: TObject);
    procedure plusClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure moinsClick(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure optionMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure optionMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure optionClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Image5MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    procedure TrayMessage(var Msg: TMessage); message WM_MYMESSAGE;
  public
    boucle:boolean;
    secondes:integer;
    temps:string;
    numero:integer;
    truc:string;
    cheminapplication:string;
    Volume:integer;
  end;

var
  Form1: TForm1;
  ID3Tag:TID3Tag;
  NotifyStruc : TNotifyIconData;
  F:textfile;

implementation

uses Unit2, Unit3;

{$R *.dfm}
{---------------------------------------------------------------}
procedure Lese_ID3Tag(Filename:string);
var
  Buffer:array[1..128] of char;
  F:File;
begin
  AssignFile(F, Filename);
  {$I-}
  Reset(F,1);
  Seek(F,FileSize(F)-128);
  BlockRead(F, Buffer, SizeOf(Buffer));
  CloseFile(F);
  with ID3Tag do begin
    ID:=copy(Buffer,1,3);
    Titel:=copy(Buffer,4,30);
    Artist:=copy(Buffer,34,30);
    Album:=copy(Buffer,64,30);
    Year:=copy(Buffer,94,4);
    Comment:=copy(Buffer,98,30);
    Genre:=ord(Buffer[128]);
  end;
  {$I+}
end;
{---------------------------------------------------------------}
procedure TForm1.Timer1Timer(Sender: TObject);
begin
if mediaplayer1.Position = mediaplayer1.Length then
begin
numero := numero +1;
if (numero = listbox1.Items.Count) and (boucle = true) then
        numero := 0;
if numero = listbox1.Items.Count then
        begin
                label1.Caption := '00 : 00';
                timer1.enabled := false
        end
else
        begin
        secondes := 0;
        mediaplayer1.Stop;
        mediaplayer1.Close;
        mediaplayer1.FileName := listbox1.Items[numero];
        mediaplayer1.Open ;
        mediaplayer1.Play;
        end;
end;
temps := inttostr(secondes div 60) + ' : ' + inttostr(secondes mod 60);
label1.Caption := temps;
secondes := secondes + 1;
end;
{---------------------------------------------------------------}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
mediaplayer1.Close;
if (@NotifyStruc<>NIL) then
   Shell_NotifyIcon(NIM_DELETE,@NotifyStruc);
end;
{---------------------------------------------------------------}
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if listbox1.ItemIndex <> -1 then
  begin
    Lese_ID3Tag(listbox1.Items[listbox1.ItemIndex]);
    label2.caption := 'Titre : ' + id3tag.Titel;
    label3.caption := 'Artiste : ' + id3tag.Artist;
    label4.caption := 'Album : ' + id3tag.Album;
    label5.caption := 'Anne : ' + id3tag.Year;
    label6.caption := 'Commentaire : ' + id3tag.Comment;
  end;

end;
{---------------------------------------------------------------}
procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
if listbox1.itemindex <> -1 then
        begin
                numero := listbox1.ItemIndex;
                mediaplayer1.FileName := listbox1.Items[listbox1.ItemIndex];
                if mediaplayer1.FileName <> '' then
                begin
                        secondes := 0;
                        mediaplayer1.Open;
                        mediaplayer1.play;
                        timer1.Enabled := true;
                end;
        end;
end;
{---------------------------------------------------------------}
procedure TForm1.Label9Click(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
  Form1.Visible:=false;
end;
{---------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  notifyStruc.cbSize:=SizeOf(notifyStruc);
  notifyStruc.Wnd:=Handle;
  notifyStruc.uID:=1;
  NotifyStruc.uFlags := NIF_ICON or NIF_TIP or NIF_MESSAGE;
  NotifyStruc.uCallbackMessage := WM_MYMESSAGE;
  NotifyStruc.hIcon :=  Form1.Image1.Picture.Icon.Handle;
  NotifyStruc.szTip:='PLAYAMP';
  Shell_NotifyIcon(NIM_ADD,@NotifyStruc);//ajoute la petite icne dans la barre des taches
  loadopt;
end;
{---------------------------------------------------------------}
procedure TForm1.TrayMessage(var Msg: TMessage);  // message WM_MYMESSAGE;
begin
  if (Msg.LParam=WM_LBUTTONDOWN) then
  begin
    Form1.Visible:=true;   // afficher la fiche
    ShowWindow(Application.Handle, SW_SHOW);
  end;
end;
{---------------------------------------------------------------}
procedure TForm1.Label8Click(Sender: TObject);
begin
saveopt;
form1.Close;
end;
{---------------------------------------------------------------}
procedure TForm1.Label10Click(Sender: TObject);
begin
form2.show
end;
{---------------------------------------------------------------}
procedure TForm1.stopMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
stop.Picture := stopon.Picture;
end;
{---------------------------------------------------------------}
procedure TForm1.stopMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
stop.Picture := stopoff.Picture;
end;
{---------------------------------------------------------------}
procedure TForm1.playMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
play.Picture := playon.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.playMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
play.Picture := playoff.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.plusMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
plus.Picture := pluson.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.plusMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
plus.Picture := plusoff.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.moinsMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
moins.Picture := moinson.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.moinsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
moins.Picture := moinsoff.Picture
end;
{---------------------------------------------------------------}
procedure TForm1.playClick(Sender: TObject);
begin
if listbox1.itemindex <> -1 then
        begin
                numero := listbox1.ItemIndex;
                mediaplayer1.FileName := listbox1.Items[listbox1.ItemIndex];
                if mediaplayer1.FileName <> '' then
                begin
                        secondes := 0;
                        mediaplayer1.Open;
                        mediaplayer1.play;
                        timer1.Enabled := true;
                end;
        end;
end;
{---------------------------------------------------------------}
procedure TForm1.plusClick(Sender: TObject);
var
i:integer;
begin
        if opendialog1.Execute = true then
        begin
                for i:= 0 to opendialog1.Files.Count-1 do
                        listbox1.Items.Add(opendialog1.Files.Strings[i]);
        end;
        opendialog1.FileName := ''
end;
{---------------------------------------------------------------}
procedure TForm1.stopClick(Sender: TObject);
begin
mediaplayer1.close;
timer1.Enabled := false;
label1.Caption := '0 : 0';
end;
{---------------------------------------------------------------}
procedure TForm1.moinsClick(Sender: TObject);
begin
listbox1.items.Delete(listbox1.ItemIndex);
end;
{---------------------------------------------------------------}
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
ReleaseCapture;
form1.Perform(WM_SYSCOMMAND, $F012, 0);
end;
{---------------------------------------------------------------}
procedure TForm1.optionMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
option.Picture := optionon.Picture;
end;
{---------------------------------------------------------------}
procedure TForm1.optionMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
option.Picture := optionoff.Picture;
end;
{---------------------------------------------------------------}
procedure Tform1.loadopt;
var
F:textfile;
begin
cheminapplication := ExtractFilePath(Application.ExeName);
If FileExists(cheminapplication + 'options.dat') Then
        begin
        assignfile(F,cheminapplication + 'options.dat');
        reset(F);
        readln(F,truc);
        if truc = '1' then boucle := true else boucle := false;
        closefile(F);
        end;
end;
{---------------------------------------------------------------}
procedure Tform1.saveopt;
begin
cheminapplication := ExtractFilePath(Application.ExeName);
assignfile(F,cheminapplication + 'options.dat');
rewrite(F);
if boucle = true then truc := '1' else truc := '0';
writeln(F,truc);
closefile(F);
end;
{---------------------------------------------------------------}
procedure TForm1.optionClick(Sender: TObject);
begin
form3.show
end;
{---------------------------------------------------------------}


procedure TForm1.Timer2Timer(Sender: TObject);
begin
form3.Top := form1.Top;
form3.Left := form1.Left + form1.Width;
end;

Procedure Tform1.RegleVolume;
Begin
   If ValGauche = 0 Then ValGauche:=1;
   If ValDroit = 0 Then ValDroit:=1;
   DVolume:=Volume Div ValDroit;
   GVolume:=Volume Div ValGauche;
   CVolume:=(DWord(DVolume) Shl 16) Or GVolume;
   //AuxSetVolume(0,Volume);
   WaveOutSetVolume(0,CVolume);
   MidiOutSetVolume(0,CVolume);
end;

procedure TForm1.Image5MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   image4.Left := (X+image3.Left);
   Volume := (image4.Left - image3.left) *1000 ;
   reglevolume;
end;

end.
