unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mmSystem, ExtCtrls;

type
  TForm3 = class(TForm)
    CheckBox1: TCheckBox;
    Button1: TButton;
    ScrollBarBalance: TScrollBar;
    ScrollBarVolume: TScrollBar;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBarVolumeChange(Sender: TObject);
    procedure ScrollBarBalanceChange(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    Procedure RegleVolume;
  end;

var
  Form3: TForm3;
  ValGauche,
  ValDroit     : Cardinal;
  GVolume,
  DVolume,
  CVolume,
  Volume       : DWord;

implementation

uses Unit1;

{$R *.dfm}
{---------------------------------------------------------------}
procedure TForm3.Button1Click(Sender: TObject);
begin
form1.boucle := checkbox1.checked;
form3.Hide;
end;
{---------------------------------------------------------------}
procedure TForm3.FormCreate(Sender: TObject);
Var
   V     : DWord;
   VG,VD : Int64;
   DV    : Integer;
begin
if form1.boucle = true then checkbox1.Checked := true else checkbox1.Checked := false;
   // Recuperer les paramtres de volume
   WaveOutGetVolume(0,@V);
   //MidiOutGetVolume(0,CVolume);

   // Sparer droite et gauche
   VG:=V And 65535;
   VD:=V And 4294901760;
   VD:=VD Shr 16;

   // Rgler la barre du volume
   If VG > VD Then ScrollBarVolume.Position:=Integer(VG)
   Else ScrollBarVolume.Position:=Integer(VD);

   // Calculer la diffrence gauche/droite
   DV:=1;
   If VG = 0 Then VG:=1;
   If VD = 0 Then VD:=1;
   If VG > VD Then DV:= -Integer(VG Div VD);
   If VD > VG Then DV:=Integer(VD Div VG);
   // Rgler la barre de la balance
   ScrollBarBalance.Position:=DV;
end;
{---------------------------------------------------------------}
procedure TForm3.ScrollBarVolumeChange(Sender: TObject);
begin
   Volume:=ScrollBarVolume.Position;
   RegleVolume;
end;
{---------------------------------------------------------------}
procedure TForm3.ScrollBarBalanceChange(Sender: TObject);
Var
   PB   : Integer;
begin
   PB:=ScrollBarBalance.Position;
   If PB < 0 Then
    begin
       ValGauche:=1;
       ValDroit:= - PB;
    end
   Else
    begin
       ValGauche:=PB;
       ValDroit:=1;
    end;
   RegleVolume;

end;

Procedure TForm3.RegleVolume;
Begin
   If ValGauche = 0 Then ValGauche:=1;
   If ValDroit = 0 Then ValDroit:=1;
   DVolume:=Volume Div ValDroit;
   GVolume:=Volume Div ValGauche;
   CVolume:=(DWord(DVolume) Shl 16) Or GVolume;
   //AuxSetVolume(0,Volume);
   WaveOutSetVolume(0,CVolume);
   MidiOutSetVolume(0,CVolume);
end;


procedure TForm3.Label3Click(Sender: TObject);
begin
if checkbox1.Checked = true then
checkbox1.Checked := false
else
checkbox1.Checked := true
end;

procedure TForm3.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
ReleaseCapture;
form3.Perform(WM_SYSCOMMAND, $F012, 0);
end;

end.
